/*
 * $Id: MethodBodyTemplateModel.java 16714 2010-04-03 00:23:10Z alexsmirnov $
 *
 * License Agreement.
 *
 * Rich Faces - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.cdk.templatecompiler;

import org.richfaces.cdk.templatecompiler.builder.model.MethodBodyStatement;

import freemarker.ext.beans.BeanModel;
import freemarker.template.TemplateModel;
import freemarker.template.TemplateModelException;

/**
 * <p class="changed_added_4_0"></p>
 *
 * @author asmirnov@exadel.com
 */
public class MethodBodyTemplateModel extends BeanModel implements TemplateModel {

    private static final String CODE_ATTRIBUTE_NAME = "code";
    
    private final MethodBodyStatement statement;
    private final JavaClassModelWrapper modelWrapper;

    /**
     * <p class="changed_added_4_0"></p>
     *
     * @param statement
     * @param javaClassModelWrapper
     */
    public MethodBodyTemplateModel(MethodBodyStatement statement, JavaClassModelWrapper javaClassModelWrapper) {
        super(statement, javaClassModelWrapper);
        this.statement = statement;
        this.modelWrapper = javaClassModelWrapper;
    }

    @Override
    public TemplateModel get(String key) throws TemplateModelException {
        if (CODE_ATTRIBUTE_NAME.equals(key)) {
            String statementCode = statement.getCode(modelWrapper.getConfiguration());
            return modelWrapper.wrap(statementCode);
        }
        return super.get(key);
    }

}
